package nz.ac.canterbury.debugassist.events;

import java.util.HashSet;
import java.util.Set;

/**
 * @author  James
 */
public class DataUpdateEventListener {

	private static DataUpdateEventListener instance;
	private Set<DataUpdateEventClient> clients;
	private DataUpdateEventListener() {
		clients = new HashSet<DataUpdateEventClient>();
	}
	public void updateAll() {
		for(DataUpdateEventClient c : clients) {
			c.updateModelRequired();
		}
		
	}

	public static DataUpdateEventListener getInstance() {
		if(instance == null) { instance = new DataUpdateEventListener(); }
		return instance;
	}
	
	public void attachElement(DataUpdateEventClient c) {
		instance.clients.add(c);
	}
	
	public void detachElement(DataUpdateEventClient c) {
		instance.clients.remove(c);
	}
}
